Imports SolidWorks.Interop
Imports SolidWorks.Interop.swconst
Imports System.Runtime.InteropServices
Imports System

Partial Class SolidWorksMacro

    Public Sub main()


            
        Dim swDoc As sldworks.ModelDoc2 = Nothing

        ' Emplacement de destination des pdf (avant la version)
        Dim sFolderTarget As String = "x:\Public\Dao\Plans PDF"
        Dim sPathName As String = ""

        swDoc = CType(swApp.ActiveDoc, sldworks.ModelDoc2)

        ' On test si le document actif est un plan et s'il a deja ete enregistr
        If swDoc.GetType = swDocumentTypes_e.swDocDRAWING Then
            sPathName = swDoc.GetPathName
            If Not IO.File.Exists(sPathName) Then
                MessageBox.Show("Le plan n'a jamais ete enregistr", "Sauvegarde PDF", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If
        Else
            MessageBox.Show("Uniquement sur un plan", "Sauvegarde PDF", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        ' On recompose le nom du pdf
        Dim stName As String = IO.Path.GetFileNameWithoutExtension(sPathName)   ' nom du document sans extension
        Dim stVersion As String = stName.Substring(4, 4)                        ' Partie version du nom
        Dim sTargetPath As String = IO.Path.Combine(sFolderTarget, stVersion)   ' dossier des pdf + version

        'on sauvegarde
        Dim lStatus As Integer = 0
        lStatus = swDoc.SaveAs3(IO.Path.Combine(sTargetPath, stName & ".pdf"), 0, 0)
    End Sub

    ''' <summary>
    ''' The SldWorks swApp variable is pre-assigned for you.
    ''' </summary>
    Public swApp As sldworks.SldWorks


End Class
